#include "Util.h"
#include <iostream>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <netdb.h>

#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>


int sendDatagramUDPtoHostname(int socket, char* HOSTNAME, char* buffer, unsigned short int destinationPort){
	   struct sockaddr_in server;
	   server.sin_family = AF_INET;
	   server.sin_addr.s_addr = inet_addr(getIP(HOSTNAME));
	   server.sin_port = htons(destinationPort);
	   return sendto( socket , buffer , strlen(buffer) , 0, (const struct sockaddr *)&server , sizeof(struct sockaddr_in) );
}


void error(const char *msg)
{
    perror(msg);
    exit(0);
}

const char* getIP(char* hostname){
	struct hostent *hp = gethostbyname(hostname);
	if (hp==0)
		error("Unknown host");
	char* ipAddress = NULL;
	struct in_addr **addr_list = (struct in_addr **)hp->h_addr_list;
    if(addr_list[0] != NULL){
    		int tam = strlen(inet_ntoa(*addr_list[0]));
    		ipAddress = new char[tam+1];
        sprintf(ipAddress, "%s", inet_ntoa(*addr_list[0]));
        ipAddress[tam] = '\0';
    }else{
    		error("Unknown host");
    }
	return ipAddress;
}
